rm(list=ls())

#chargement des donnes
setwd("F:/traitements/us-census-1990")
print("Chargement")
donnees <- read.table(file="sample-census.txt",header=T,dec=".")

#acp, en fixant le nombre de facteurs  extraire  10
nb.facteurs <- 10
print("ACP")
acp <- princomp(donnees,scores=T,cor=T)
facteurs.acp <- acp$scores[,1:nb.facteurs]

#initialiser toujours de la mme manire le gnrateur de nombre alatoire
#pour avoir le mme rsultat d'une excution  l'autre
set.seed(10)

#K-Means, en fixant le nombre de pr-classes
nb.preclusters <- 50
print("K-Means")
obj.kmeans <- kmeans(facteurs.acp,centers=nb.preclusters,algorithm="MacQueen",iter.max=40)
clus.kmeans <- obj.kmeans$cluster
id.clus.kmeans <- factor(clus.kmeans)

#CAH  partir des pr-classes du K-Means
print("CAH")
obj.cah <- hclust(dist(obj.kmeans$centers)^2,method="ward",members=table(id.clus.kmeans))
plot(obj.cah)

#couper l'arbre  X classes
nb.finalclusters <- 3
groupe <- cutree(obj.cah,k=nb.finalclusters)

#affectation des classes aux observations
#en faisant la correspondance avec les groupes du K-Means
cah.classe <- numeric(nrow(donnees))
for (k in 1:nlevels(id.clus.kmeans)){
  cah.classe[id.clus.kmeans == k] <- groupe[k]
}
cah.classe <- as.factor(cah.classe)

#effectifs par classe
print(summary(cah.classe))

#comparaison des caractristiques des classes avec ceux de Tanagra
#chargement des classes produites par Tanagar
setwd("D:/DataMining/Databases_for_mining/comparison_TOW/clustering_big_dataset")
tanagra.output <- read.table(file="tanagra-clusters.txt",dec=".",header=T)
tanagra.classe <- tanagra.output$Cluster_HAC_1

#croisement des classes Tanagra et R
croisement <- table(tanagra.classe,cah.classe)
print(croisement)
